// DirectX.h: interface for the CDirectX class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(DIRECTX_H_INCLUDED)
#define DIRECTX_H_INCLUDED

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CDirectX  
{
public:
	char Msg[15][100];
	long Till[15];

public:
	LPDIRECTSOUND lpDS;
	LPDIRECTSOUNDBUFFER lpDSB;
	LPDIRECTSOUNDBUFFER lpDSBPrimary;

	bool DSAvailable;
	WAVEFORMATEX wfx;

public:
	HRESULT dErr;
	LPDIRECTDRAW lpDD;
	LPDIRECTDRAWCLIPPER lpDDClipper;
	LPDIRECTDRAWPALETTE lpDDPalette;

	LPDIRECTDRAWSURFACE lpDDSPrimary;
	LPDIRECTDRAWSURFACE lpDDSBack;
	LPDIRECTDRAWSURFACE lpDDSOffScreen;

	LPDIRECTDRAWSURFACE2 lpDDSPrimary2;
	LPDIRECTDRAWSURFACE2 lpDDSBack2;
	LPDIRECTDRAWSURFACE2 lpDDSOffScreen2;

	int Width, Height;
	char Depth;
	bool Windowed, DoubleBuffered;

	bool fpsShow;
	long fpsLast;
	double fpsAvg[100];

	HFONT hFont;
	
	DDPIXELFORMAT DDPixelFormat;
public:
	void OnScreenMsg( char *pMsg, int pDur);
	bool BltSurface( int pWidth, int pHeight);
	bool UnlockSurface( void);
	bool LockSurface( BYTE **lpSurface, DWORD *lpPitch);
	bool SetSoundMode( void);
	bool SetDisplayMode( 
		int pWidth, int pHeight, 
		char pDepth, bool pWindowed, 
		bool pDoubleBuffered);
	void DeInitialize();
	bool Initialize();
	CDirectX();
	virtual ~CDirectX();

private:
	bool CreateSoundThread( void);
	bool CreateSoundTimer( void);
};

extern CDirectX DirectX;

#endif // !defined(DIRECTX_H_INCLUDED)
